#version 100

#extension GL_OES_EGL_image_external : require

precision highp float;

varying vec2 vTexCoord;

#if defined (EXTERNAL_OES_VIDEO_TEXTURE)
uniform samplerExternalOES sVideoTexture;
#elif defined (TEXTURE_2D_VIDEO_TEXTURE)
uniform sampler2D sVideoTexture;
#endif

uniform sampler2D lookupTexture;

void main() {
    vec4 lookupSample = texture2D(lookupTexture, vTexCoord);

    highp vec2 videoCoord;
    videoCoord.x = (lookupSample.r * 255.0 + lookupSample.g * 255.0 * 256.0) / 65535.0;
    videoCoord.y = (lookupSample.b * 255.0 + lookupSample.a * 255.0 * 256.0) / 65535.0;

    // There is an issue in note9 with this shader in certain paths. In order to prevent that issue we are storing the
    // result in an additional variable. For more details: https://jira.sc-corp.net/browse/SPECENG-30451
    vec4 videoTextureColor = texture2D(sVideoTexture, videoCoord);
    gl_FragColor = videoTextureColor;
}
