"use strict";var i=require("TSLib").__extends;var r=require("TSLib").__awaiter;var a=require("TSLib").__generator;Object.defineProperty(exports,"__esModule",{value:true});var e=require("Composer");var t=require("Device");exports.Device=t;var o=require("./Logger");var s=require("./stores/SubscriptionStore");var n=require("./stores/PublisherStore");var h=require("./services/RequestService");var u=require("../../common_profile/src/misc/BitmojiUrlProvider");var c=require("../../common_profile/src/util/PlaybackUtils");var l=require("../../common/src/util/MiscUtils");var d=require("../../common_profile/src/proto");var p=require("../../common_profile/src/Strings");exports.Strings=p.default;var f=require("../../common_profile/src/misc/ActionSheetActions");var g=require("../../common/src/util/AlertUtils");exports.DEFAULT_PRIMARY_COLOR="#1A1A1A";var b=350;var S=280;var w=function(t){i(e,t);function e(){var e=t!==null&&t.apply(this,arguments)||this;e.logger=null;e.rootViewFrame={x:0,y:0,width:0,height:0};e.scrollViewBodyFrame={x:0,y:0,width:0,height:0};e.headerViewFrame={x:0,y:0,width:0,height:0};e.headerBarViewFrame={x:0,y:0,width:0,height:0};e.lastScrollEvent={x:0,y:0};e.displayInsetObserver=null;e.state={publisherInfo:n.default.emptyPublisherInfo(),episodeViewModels:[],subscribeAreaHidden:false,showSpinner:true,showLoadingStubs:true,headerHeight:S,hideLogoUrl:true};return e}e.prototype.onCreate=function(){var e=this;this.subscriptionStore=new s.default(this);this.notificationStore=new s.default(this);this.logger=new o.default;this.displayInsetObserver=exports.Device.observeDisplayInsetChange(function(){e.render()});this.onViewModelUpdated()};e.prototype.onDestroy=function(){this.logger.onDestroy();if(this.displayInsetObserver){this.displayInsetObserver.cancel()}};e.prototype.onViewModelUpdated=function(){if(!this.viewModel){return}this.requestService=new h.default({accountServiceUrl:this.viewModel.accountServiceUrl});var e=d.impala.PublisherProfileLaunchInfo.decode(this.viewModel.encodedLaunchInfo);this.applyLaunchInfo(e)};e.prototype.applyLaunchInfo=function(e){var t=this;if(!this.publisherStore||this.publisherStore.businessProfileId!==e.businessProfileId){var i=this.viewModel.bitmojiAvatarId&&this.viewModel.bitmojiAvatarId.length?new u.default(this.viewModel.bitmojiAvatarId):null;this.publisherStore=new n.default(e,this.requestService,i)}var r=e.isSubscribed!==this.subscriptionStore.state;this.subscriptionStore.state=e.isSubscribed;this.notificationStore.state=e.isSubscribed&&e.isSubscribedNotifications;if(r){this.applySubscribed(this.subscriptionStore.state,false)}this.publisherStore.getPublisherInfo().then(function(e){t.setState({publisherInfo:e},function(){t.applyPublisherInfo(e)})}).catch(function(e){console.error("Error getting publisher info");t.showErrorView()})};e.prototype.applyPublisherInfo=function(e){var t=this;this.state.headerHeight=this.calculateBackgroundHeight();var i=e.websiteUrl&&e.websiteUrl.length>0||false;this.logger.pageId=e.publisherId;this.logger.onViewModelUpdated(this.viewModel.sourcePageType,this.viewModel.pageEntryType,i);this.publisherStore.episodeStore.getItems().then(function(e){t.applyEpisodes(e)}).catch(function(e){console.error("Error getting initial episodes list");t.showErrorView()});this.updateHeaderBarViewModel();if(this.calculateBackgroundHeight()!==this.state.headerHeight){this.updateBackgroundHeightAnimated()}e.horizontalLogoHiddenPromise.then(function(e){t.setState({hideLogoUrl:e})}).catch(function(e){console.error("Error checking if logo should be displayed")})};e.prototype.showBackgroundImage=function(){return!!this.state.publisherInfo.backgroundImageUrl};e.prototype.calculateBackgroundHeight=function(){return this.showBackgroundImage()?b:S};e.prototype.getHorizontalLogoUrl=function(){if(this.state.hideLogoUrl){return undefined}return this.state.publisherInfo.horizontalLogoUrl};e.prototype.onChildComponentCreated=function(e){if(e.elementIdWithinParent==="actionSheet"){e.setDelegate(this)}if(e.elementIdWithinParent==="episodeActionSheet"){e.setDelegate(this)}if(e.elementIdWithinParent==="headerBar"){e.delegate=this}};e.prototype.getEpisodesContainerClass=function(){var e=["episodes-container"];switch(this.getEpisodeViewStyle()){case 0:e.push("style-default");break;case 1:e.push("style-tile");break}return e.join(" ")};e.prototype.shouldRenderSectionTitle=function(){return this.getEpisodeViewStyle()===0};e.prototype.onScroll=function(e){this.lastScrollEvent=e;if(this.rootViewFrame.height===0||this.scrollViewBodyFrame.height===0){return}var t=this.headerViewFrame.height-this.headerBarViewFrame.height;var i=this.getHeaderBarView();if(i){var r=this.calculateBackgroundHeight()-50;var o=l.mapNumber(e.y,r*.4,r*.65,0,1);i.updatePercent(o,o)}var s=this.getHeaderView();if(s){s.onScroll(e)}this.maybeFetchMoreEpisodesForScrollEvent(e)};e.prototype.onTapSubscribeButton=function(){this.subscriptionStore.toggleState("DEFAULT")};e.prototype.onTapWebsiteUrl=function(){var e=this.state.publisherInfo.websiteUrl;if(e&&e.length){if(e.indexOf("http://")<0&&e.indexOf("https://")<0){e="https://"+e}this.actions.openURL({url:e});this.logger.onOpenWebView("DEFAULT")}};e.prototype.onTapErrorViewReloadButton=function(){this.publisherStore=null;this.onViewModelUpdated();this.render()};e.prototype.onLayoutScrollViewBody=function(e){this.scrollViewBodyFrame=e};e.prototype.onLayoutRootView=function(e){this.rootViewFrame=e};e.prototype.onLayoutHeaderBarView=function(e){this.headerBarViewFrame=e};e.prototype.onHeaderViewUpdateBackgroundAttributes=function(e){this.elements.backgroundImage.attributes=e;this.renderWithoutTemplate()};e.prototype.onLongPressEpisode=function(e){var t=this.getEpisodeActionSheet();var i=this.getEpisodeActionSheetViewModelForEpisode(e.episode);if(t&&i){t.showWithViewModel(i)}};e.prototype.getEpisodeViewStyle=function(){return this.state.publisherInfo.isBitmojiPublisher?1:0};e.prototype.updateHeaderBarViewModel=function(){var e=this.notificationStore.updating?!this.notificationStore.state:this.notificationStore.state;this.setState({headerBarViewModel:{optInNotifications:e,subscribed:this.subscriptionStore.state,title:this.state.publisherInfo.title,optInNotificationsABEnabled:this.viewModel.notificationsABTestEnabled}})};e.prototype.updateBackgroundHeightAnimated=function(){var e=this;var t=this.state.headerHeight;var i=this.calculateBackgroundHeight();this.render();this.animate({duration:.5},function(){e.state.headerHeight=i})};e.prototype.applyEpisodes=function(e){var i=this;var t=this.state.episodeViewModels.length>0;var r=[];e.forEach(function(e,t){if(t<i.state.episodeViewModels.length&&i.state.episodeViewModels[t].episode.episodeId===e.episodeId){r.push(i.state.episodeViewModels[t]);return}r.push({episode:e,style:i.getEpisodeViewStyle(),playStoryDoc:function(){i.publisherStore.episodeStore.getItems().then(function(e){i.playStoryDoc(e,t)})},onImpression:function(){i.logger.onEpisodeImpression(e,t)}})});this.setState({episodeViewModels:r,showSpinner:this.publisherStore.episodeStore.hasNextPage},function(){if(!t){i.animate({duration:.2},function(){i.state.showLoadingStubs=false})}})};e.prototype.playStoryDoc=function(s,n){return r(this,void 0,void 0,function(){var i,r,t,o;return a(this,function(e){switch(e.label){case 0:this.logger.onPlayEpisode(s[n],n);i=[];r=this.getEpisodeViews();s.forEach(function(e,t){i.push({episode:e,baseViewPromise:r[t].getBaseView()})});return[4,c.resolvePlaybackItems(i,n)];case 1:t=e.sent();o=t.encodedStories.map(function(e){return e.storyDoc});this.actions.playStoryDoc(o,t.startingIndex,this.publisherStore.encodedLaunchInfo,t.baseViews,"PROFILE_PUBLISHER_EDITIONS");return[2]}})})};e.prototype.fetchMorePaddingForEpisodeViewStyle=function(e){switch(this.getEpisodeViewStyle()){case 0:return 400;case 1:return 800}};e.prototype.maybeFetchMoreEpisodesForScrollEvent=function(e){var t=this;var i=this.fetchMorePaddingForEpisodeViewStyle(this.getEpisodeViewStyle());var r=e.y+this.rootViewFrame.height+i;var o=this.scrollViewBodyFrame.y+this.scrollViewBodyFrame.height;if(r<o){return}if(!this.publisherStore.episodeStore.hasNextPage||this.publisherStore.episodeStore.isFetching||this.publisherStore.episodeStore.msSinceLastFetchAttempt<500){return}this.publisherStore.episodeStore.fetchNextPage().then(function(){t.publisherStore.episodeStore.getItems().then(function(e){t.applyEpisodes(e)})})};e.prototype.getHeaderBarView=function(){if(this.children&&this.children.headerBar&&this.children.headerBar.length){return this.children.headerBar[0]}return null};e.prototype.getHeaderView=function(){if(this.children&&this.children.header&&this.children.header.length){return this.children.header[0]}return null};e.prototype.getSubscribeButton=function(){if(this.children&&this.children.subscribeButton&&this.children.subscribeButton.length){return this.children.subscribeButton[0]}return null};e.prototype.getActionSheet=function(){if(this.children&&this.children.actionSheet&&this.children.actionSheet.length){return this.children.actionSheet[0]}return null};e.prototype.getEpisodeActionSheet=function(){if(this.children&&this.children.episodeActionSheet&&this.children.episodeActionSheet.length){return this.children.episodeActionSheet[0]}return null};e.prototype.getEpisodeViews=function(){if(this.children&&this.children.episodeView&&this.children.episodeView.length){var e=[];for(var t=0,i=this.children.episodeView;t<i.length;t++){var r=i[t];e.push(r)}return e}return[]};e.prototype.getNotificationView=function(){if(this.children&&this.children.notificationView&&this.children.notificationView.length){return this.children.notificationView[0]}return null};e.prototype.getErrorView=function(){if(this.children&&this.children.errorView&&this.children.errorView.length){return this.children.errorView[0]}return null};e.prototype.showErrorView=function(){var e=this.getErrorView();if(e){e.show()}};e.prototype.applySubscribed=function(e,t){var i=this;var r=this.getSubscribeButton();if(!t){this.state.subscribeAreaHidden=e;if(r){r.viewModel={subscribed:e}}this.updateHeaderBarViewModel();this.render();return Promise.resolve()}var o=this.getHeaderBarView();if(o){o.setSubscribedAnimated({duration:e?.55:.2,controlPoints:[1,.01,.65,1.33]},e)}if(r){r.setSubscribing(false);r.setViewModelAnimated({duration:e?.05:0},{subscribed:e})}var s=this.updateEpisodesLimitToViewportForAnimation();return this.animate({duration:e?.55:.2,controlPoints:[.5,-.02,1,-.2]},function(){i.elements.subscribeButton.attributes.scaleX=e?0:1;i.elements.subscribeButton.attributes.scaleY=e?0:1}).then(function(){return i.animate({duration:.3},function(){i.state.subscribeAreaHidden=e})}).then(function(){i.updateHeaderBarViewModel();i.resetEpisodesLimitToViewport(s);i.render()}).catch(function(e){console.log("Error animating subscribe state",e)})};e.prototype.toggleSubscribedWithAlertIfNeeded=function(t){var i=this;if(this.subscriptionStore.state){g.displayAlertIfAvailable({title:exports.Strings.unsubscribe(),description:exports.Strings.confirmUnsubscribe(this.state.publisherInfo.title),buttonText:exports.Strings.yes(),cancelButtonText:exports.Strings.cancel(),swipeToDismiss:true,style:"destructive"}).then(function(e){if(e){i.subscriptionStore.toggleState(t)}})}else{this.subscriptionStore.toggleState(t)}};e.prototype.toggleNotificationsWithNotificationIfNeeded=function(e){var t=this;var i=this.notificationStore.state;this.notificationStore.toggleState(e);if(!i&&exports.Device.getSystemType()!=="android"){setTimeout(function(){var e=t.getNotificationView();if(e){e.show(exports.Strings.notificationsBanner(t.state.publisherInfo.title))}},250)}};e.prototype.getActionSheetViewModel=function(){var e=[this.subscriptionStore.state?f.unsubscribeAction:f.subscribeAction];if(this.subscriptionStore.state&&this.viewModel.notificationsABTestEnabled){e.push(this.notificationStore.state?f.optOutAction:f.optInAction)}if(this.state.publisherInfo.deeplinkUrl.length>0&&this.state.publisherInfo.isShareable){e.push(f.shareUrlActionForUrl(this.state.publisherInfo.deeplinkUrl))}e.push(f.hidePublisherActionForName(this.state.publisherInfo.title));return f.actionSheetViewModelForActions(e)};e.prototype.getEpisodeActionSheetViewModelForEpisode=function(e){if(e.isShareable&&e.deeplinkUrl.length){return f.actionSheetViewModelForActions([f.shareUrlActionForUrl(e.deeplinkUrl)])}return null};e.prototype.updateEpisodesLimitToViewportForAnimation=function(){var e=[];var t=this.elements.episodeView.forEachChildren.children;var i=false;for(var r in t){var o=t[r].episodeView;var s=o.component;i=i||s.hasView;if(!s.hasView&&i){e.push(o)}}var n=[];for(var a=0;a<Math.min(e.length,3);a+=1){e[a].attributes.limitToViewport=false;n.push(e[a])}return n};e.prototype.resetEpisodesLimitToViewport=function(e){var t=this.elements.episodeView.forEachChildren.children;for(var i in t){t[i].episodeView.attributes.limitToViewport=true}};e.prototype.headerBarViewDidTapDownArrow=function(e){this.actions.dismiss()};e.prototype.headerBarViewDidTapSubscribeButton=function(e){this.toggleSubscribedWithAlertIfNeeded("DEFAULT")};e.prototype.headerBarViewDidTapOptInNotificationsButton=function(e){this.toggleNotificationsWithNotificationIfNeeded("DEFAULT")};e.prototype.headerBarViewDidTapMenuButton=function(e){var t=this.getActionSheet();if(t){t.showWithViewModel(this.getActionSheetViewModel());this.logger.onOpenActionMenu()}};e.prototype.updateStateForSubscriptionStore=function(r,o){var s=this;return this.publisherStore.getPublisherInfo().then(function(e){return new Promise(function(t,i){if(r===s.subscriptionStore){s.actions.setSubscribeState(o,e.publisherId,function(e){if(e){i(e);return}t()})}if(r===s.notificationStore){s.actions.setNotificationsState(o,e.publisherId,function(e){if(e){i(e);return}t()})}})})};e.prototype.subscriptionStoreStateDidChange=function(e,t){if(e===this.subscriptionStore){this.applySubscribed(e.state,true);this.logger.onSubscribedChanged(e.state,t)}if(e===this.notificationStore){this.updateHeaderBarViewModel();this.logger.onOptInToNotificationsChanged(e.state,t)}};e.prototype.subscriptionStoreUpdatingDidChange=function(e){if(e===this.subscriptionStore){var t=this.getSubscribeButton();if(t){t.setSubscribing(e.updating)}}if(e===this.notificationStore){this.updateHeaderBarViewModel()}};e.prototype.actionSheetWantsAction=function(e,t){var i=this;if(t===f.subscribeAction||t===f.unsubscribeAction){this.toggleSubscribedWithAlertIfNeeded("PROFILE_ACTION_MENU");return true}if(t===f.optInAction||t===f.optOutAction){this.toggleNotificationsWithNotificationIfNeeded("PROFILE_ACTION_MENU");return true}if(t.id===f.SHARE_URL_ACTION_ID){this.actions.shareURL(t.userData);this.logger.onShare("PROFILE_ACTION_MENU");return true}if(t.id===f.HIDE_PUBLISHER_ACTION_ID){this.actions.hidePublisher(function(e){i.logger.onHide("PROFILE_ACTION_MENU");if(!e){i.actions.dismiss()}});return true}return false};return e}(e.PureComponent);exports.PublisherProfile=w;w.componentPath="publisher_profile:src/PublisherProfile.composer";
